%if 0%{?fedora} || 0%{?rhel} >= 6
%global with_devel 1
%global with_bundled 0
%global with_debug 0
%global with_check 1
%global with_unit_test 1
%else
%global with_devel 0
%global with_bundled 0
%global with_debug 0
%global with_check 0
%global with_unit_test 0
%endif

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

%global provider        github
%global provider_tld    com
%global project         kardianos
%global repo            govendor
# https://github.com/kardianos/govendor
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global import_path     %{provider_prefix}
%global commit          6be156c795774e9e24709ae384d8f4da55e6e192
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

Name:           golang17-%{provider}-%{project}-%{repo}
Version:        0
Release:        0.1.git%{shortcommit}%{?dist}
Summary:        !!!!FILL!!!!
License:        !!!!FILL!!!!
URL:            https://%{provider_prefix}
Source0:        https://%{provider_prefix}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz

# e.g. el6 has ppc64 arch without gcc-go, so EA tag is required
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 %{arm}}
# If go_compiler is not set to 1, there is no virtual provide. Use golang instead.
BuildRequires:  golang17
BuildRequires:  git-daemon
%global gopath /usr/lib/golang17

%description
%{summary}

%if 0%{?with_devel}
%package devel
Summary:       %{summary}
BuildArch:     noarch

%if 0%{?with_check} && ! 0%{?with_bundled}
BuildRequires: golang17(github.com/Bowery/prompt)
BuildRequires: golang17(github.com/dchest/safefile)
BuildRequires: golang17(github.com/google/shlex)
BuildRequires: golang17(github.com/pkg/errors)
BuildRequires: golang17(golang.org/x/tools/go/vcs)
%endif

Requires:      golang17(github.com/Bowery/prompt)
Requires:      golang17(github.com/dchest/safefile)
Requires:      golang17(github.com/google/shlex)
Requires:      golang17(github.com/pkg/errors)
Requires:      golang17(golang.org/x/tools/go/vcs)

Provides:      golang17(%{import_path}/cliprompt) = %{version}-%{release}
Provides:      golang17(%{import_path}/context) = %{version}-%{release}
Provides:      golang17(%{import_path}/help) = %{version}-%{release}
Provides:      golang17(%{import_path}/migrate) = %{version}-%{release}
Provides:      golang17(%{import_path}/pkgspec) = %{version}-%{release}
Provides:      golang17(%{import_path}/prompt) = %{version}-%{release}
Provides:      golang17(%{import_path}/run) = %{version}-%{release}
Provides:      golang17(%{import_path}/vcs) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendor/github.com/Bowery/prompt) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendor/github.com/dchest/safefile) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendor/github.com/google/shlex) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendor/github.com/pkg/errors) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendor/golang.org/x/tools/go/vcs) = %{version}-%{release}
Provides:      golang17(%{import_path}/vendorfile) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for
building other packages which use import path with
%{import_path} prefix.
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%package unit-test-devel
Summary:         Unit tests for %{name} package
%if 0%{?with_check}
#Here comes all BuildRequires: PACKAGE the unit tests
#in %%check section need for running
%endif

# test subpackage tests code from devel subpackage
Requires:        %{name}-devel = %{version}-%{release}

%description unit-test-devel
%{summary}

This package contains unit tests for project
providing packages with %{import_path} prefix.
%endif

%prep
%setup -q -n %{repo}-%{commit}

%build

%install
# source codes for building projects
%if 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
echo "%%dir %%{gopath}/src/%%{import_path}/." >> devel.file-list
# find all *.go but no *_test.go files and generate devel.file-list
for file in $(find . -iname "*.go" \! -iname "*_test.go") ; do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> devel.file-list
done
%endif

# testing files for this project
%if 0%{?with_unit_test} && 0%{?with_devel}
install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
# find all *_test.go files and generate unit-test.file-list
for file in $(find . -iname "*_test.go"); do
    echo "%%dir %%{gopath}/src/%%{import_path}/$(dirname $file)" >> devel.file-list
    install -d -p %{buildroot}/%{gopath}/src/%{import_path}/$(dirname $file)
    cp -pav $file %{buildroot}/%{gopath}/src/%{import_path}/$file
    echo "%%{gopath}/src/%%{import_path}/$file" >> unit-test-devel.file-list
done
%endif

%if 0%{?with_devel}
sort -u -o devel.file-list devel.file-list
%endif

%check
%if 0%{?with_check} && 0%{?with_unit_test} && 0%{?with_devel}
%if ! 0%{?with_bundled}
export GOPATH=%{buildroot}/%{gopath}:%{gopath}
%else
export GOPATH=%{buildroot}/%{gopath}:$(pwd)/Godeps/_workspace:%{gopath}
%endif

%global gotest /usr/lib/golang17/bin/go test

%gotest %{import_path}/context
%gotest %{import_path}/internal/pathos
%gotest %{import_path}/internal/vfilepath
%gotest %{import_path}/migrate
%gotest %{import_path}/pkgspec
%gotest %{import_path}/run
%gotest %{import_path}/vcs
%gotest %{import_path}/vendor/github.com/dchest/safefile
%gotest %{import_path}/vendor/github.com/google/shlex
%gotest %{import_path}/vendorfile
%endif

#define license tag if not already defined
%{!?_licensedir:%global license %doc}

%if 0%{?with_devel}
%files devel -f devel.file-list
%license LICENSE
%doc README.md
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%endif

%if 0%{?with_unit_test} && 0%{?with_devel}
%files unit-test-devel -f unit-test-devel.file-list
%license LICENSE
%doc README.md
%endif

%changelog
* Fri Dec 16 2016 RJ Bergeron - 0-0.1.git6be156c
- First package for Fedora


